
## define to enable immodule -- Rex
%define immodule 20060318 
%{?immodule:Provides: qt-immodule = %{immodule}}

# Build SQL plugins
%define buildSQL 1
# define to build sqlite(2) plugin too
#define sqlite 1

# visibility
#define enable_hidden_visibility 1

# Build QT styles into -styles subpkg
%define styleplugins 0 

# cvs/svn date -- Rex
%define qtcopy 20061103
# To be able to identify qt-copy versions
%{?qtcopy:Provides: qt-copy = %{qtcopy}}

# define to use redhat-artwork/Bluecurve, undef otherwise
%define redhat_artwork 1

Summary: Qt GUI toolkit
Name: 	 qt
Epoch:	 1
Version: 3.3.7
Release: 0.2%{?dist}%{?kde}

License: GPL/QPL
Group:   System Environment/Libraries
URL:     http://www.troll.no/
#if "%{?qtcopy:1}" == "1"
%if 0
Source0: qt-copy-3.3-svn%{qtcopy}.tar.bz2
Source1000: qt-copy-svn_checkout.sh
%else
Source0: ftp://ftp.troll.no/qt/source/qt-x11-free-%{version}.tar.bz2
Source1: qt-copy-patches-%{qtcopy}.tar.gz
%endif
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%define qt_ver2 %{expand:%%(echo %%{version} | cut -d. -f-2)}
%define qt_dirname qt-%{qt_ver2}
%define qtdir %{_libdir}/%{qt_dirname}
%define qt_docdir %{_docdir}/%{name}-devel-%{version}
# Be careful about ever changing this, some 3rd-party libs install here -- Rex
%define qt_libdir %{qtdir}/lib
#Prefix: %{qtdir}
Source2: qtrc

Source4: designer3.desktop
Source5: assistant3.desktop
Source6: linguist3.desktop
Source7: qtconfig3.desktop

Source10: qt.sh
Source11: qt.csh

Source20: assistant.desktop
Source21: designer.desktop
Source22: linguist.desktop
Source23: qtconfig.desktop

Patch1: qt-3.3.4-print-CJK.patch
Patch2: qt-3.0.5-nodebug.patch
Patch3: qt-3.1.0-makefile.patch
Patch5: qt-x11-free-3.3.6-strip.patch
Patch7: qt-x11-free-3.3.2-quiet.patch
Patch8: qt-x11-free-3.3.3-qembed.patch
Patch12: qt-uic-nostdlib.patch
Patch13: qt-x11-free-3.3.6-qfontdatabase_x11.patch
Patch14: qt-x11-free-3.3.3-gl.patch
Patch19: qt-3.3.3-gtkstyle.patch
Patch20: qt-x11-free-3.3.5-gcc4-buildkey.patch
Patch23: qt-visibility.patch
Patch24: qt-x11-free-3.3.5-uic.patch
Patch25: qt-x11-free-3.3.7-uic-multilib.patch

## immodule patches 
# http://freedesktop.org/wiki/Software/immodule-qt 
# http://people.freedesktop.org/~daisuke/
#Patch50: http://people.freedesktop.org/~daisuke/qt-x11-immodule-unified-qt3.3.5-20051018.diff.bz2
#Patch50: http://people.freedesktop.org/~daisuke/qt-x11-immodule-unified-qt3.3.5-20060318.diff.bz2
Patch50: qt-x11-free-3.3.6-qt-x11-immodule-unified-qt3.3.5-20060318-pre.patch
Patch51: http://people.freedesktop.org/~daisuke/qt-x11-immodule-unified-qt3.3.5-%{immodule}.diff.bz2
Patch52: qt-x11-free-3.3.6-qt-x11-immodule-unified-qt3.3.5-20060318-post.patch
Patch53: qt-x11-immodule-unified-qt3.3.5-20051012-quiet.patch
Patch54: qt-x11-free-3.3.6-fix-key-release-event-with-imm.diff
Patch55: qt-x11-free-3.3.6-qt-x11-immodule-unified-qt3.3.5-20060318-resetinputcontext.patch

# qt-copy patches
Patch100: 0038-dragobject-dont-prefer-unknown.patch
Patch101: 0047-fix-kmenu-width.diff
Patch102: 0048-qclipboard_hack_80072.patch
Patch103: 0056-khotkeys_input_84434.patch
Patch104: 0069-fix-minsize.patch
Patch105: 0070-fix-broken-fonts.patch

# upstream patches
Patch200: qt-x11-free-3.3.4-fullscreen.patch
Patch201: qt-x11-free-3.3.6-arabic_fonts.patch

## kde-redhat patches
# fix head-usage in apply-patches
Patch1000: qt-copy-x86_64.patch
Patch1001: http://home.earthlink.net/~tyrerj/files/qt-x11-free-3.3.3-PSfontname.patch.bz2
## http://bugzilla.redhat.com/210742 - CVE-2006-4811 qt integer overflow
Patch1003: qt3-pixmap.patch

# Not *strictly* required -- Rex
%if "%{?redhat_artwork:1}" == "1"
Requires(hint): %{qtdir}/etc/settings/qtrc
#Requires(hint): redhat-artwork 
%endif

Requires(post): /sbin/ldconfig fileutils
Requires(postun): /sbin/ldconfig fileutils

# Wierd, but true. (-: Not sure why, yet -- Rex
# leaves unpackaged files in %%_docdir/%name-%oldversion
#BuildConflicts: qt-devel < %{epoch}:%{version}

BuildRequires: libmng-devel
BuildRequires: libjpeg-devel
BuildRequires: libpng-devel
BuildRequires: perl
BuildRequires: sed
BuildRequires: findutils
BuildRequires: cups-devel
BuildRequires: pkgconfig
BuildRequires: desktop-file-utils

%if "%{?fedora}" > "3" || "%{?rhel}" > "3"
%define nas     -system-nas-sound
%endif

%if "%{?nas}" == "-system-nas-sound"
BuildRequires: nas-devel
%endif

## ld_so_conf_d support?
%define ld_so_conf_d %(if [ -d /etc/ld.so.conf.d ]; then echo 1; else echo 0; fi)
%if "%{?ld_so_conf_d}" == "1"
Requires: /etc/ld.so.conf.d
%endif

## X11 support
## In theory, should be as simple as:
#define x_deps libGL-devel libGLU-devel
## but, "xorg-x11-devel: missing dep on libGL/libGLU" - http://bugzilla.redhat.com/211898
%define x_deps xorg-x11-devel xorg-x11-Mesa-libGL xorg-x11-Mesa-libGLU
%define xrandr -xrandr
%global xft  -xft %(pkg-config --cflags xft 2>/dev/null)
%if "%{?fedora}" > "4" || "%{?rhel}" > "4"
%define x_deps libICE-devel libSM-devel libXcursor-devel libXext-devel libXft-devel libXinerama-devel libXrandr-devel libXrender-devel libXt-devel libX11-devel xorg-x11-proto-devel libGL-devel libGLU-devel
BuildRequires: libXmu-devel
%define x_modular 1
%endif
%define x_deps_all %{?x_deps} fontconfig-devel
BuildRequires: %{x_deps_all} 

#Obsoletes: qt-Xt < %{epoch}:%{version}-%{release}

%if "%{?styleplugins}" != "1"
Obsoletes: qt-styles < %{epoch}:%{version}-%{release}
Provides:  qt-styles = %{epoch}:%{version}-%{release}
%endif

%description
Qt is a GUI software toolkit which simplifies the task of writing and
maintaining GUI (Graphical User Interface) applications
for the X Window System.

Qt is written in C++ and is fully object-oriented.

This package contains the shared library needed to run qt
applications, as well as the README files for qt.

%package config
Summary: Grapical configuration tool for programs using Qt
Group:	 User Interface/Desktops
Requires: %{name} = %{epoch}:%{version}-%{release}
%description config
A grapical configuration tool for programs using Qt.

%package devel
Summary: Development files for the Qt GUI toolkit.
Group: 	 Development/Libraries
Requires: %{name} = %{epoch}:%{version}-%{release} 
Requires: %{x_deps_all}
Requires: libpng-devel
Requires: libjpeg-devel
Requires: pkgconfig
%description devel
The qt-devel package contains the files necessary to develop
applications using the Qt GUI toolkit: the header files, the Qt meta
object compiler, the man pages, the HTML documentation and example
programs.

%package devel-docs
Group: Documentation
Summary: API documentation for %{name}
Requires: %{name} = %{epoch}:%{version}-%{release}
Provides:  %{name}-doc = %{epoch}:%{version}-%{release}
%description devel-docs
API documentation for %{name}-%{version}.

%if "%{?styleplugins}" == "1"
%define plugins_style -plugin-style-cde -plugin-style-motifplus -plugin-style-platinum -plugin-style-sgi -plugin-style-windows -plugin-style-compact
%package styles
Summary: Extra styles for the Qt GUI toolkit.
Group: User Interface/Desktops
Requires: %{name} = %{epoch}:%{version}-%{release} 
%description styles
Extra styles (themes) for the Qt GUI toolkit.
%else
%define plugins_style -qt-style-cde -qt-style-motifplus -qt-style-platinum -qt-style-sgi -qt-style-windows -qt-style-compact
%endif

%if "%{?buildSQL}" == "1"
%define plugins_sql -enable-sql -plugin-sql-mysql -plugin-sql-odbc -plugin-sql-psql %{?sqlite:-plugin-sql-sqlite}
%package ODBC
Summary: ODBC drivers for Qt's SQL classes
Group: System Environment/Libraries
BuildRequires: unixODBC-devel
Requires: %{name} = %{epoch}:%{version}
%description ODBC
%{summary}.

%package MySQL
Summary: MySQL drivers for Qt's SQL classes
Group: System Environment/Libraries
BuildRequires:  mysql-devel 
Requires: %{name} = %{epoch}:%{version}
%description MySQL
%{summary}.

%package PostgreSQL
Summary: PostgreSQL drivers for Qt's SQL classes
Group: System Environment/Libraries
BuildRequires:  postgresql-devel
Requires: %{name} = %{epoch}:%{version}
%description PostgreSQL
%{summary}.

%if "%{?sqlite:1}" == "1"
%package SQLite
Summary: SQLite drivers for Qt's SQL classes.
Group: System Environment/Libraries
BuildRequires: sqlite2-devel >= 2.8.13
Requires: %{name} = %{epoch}:%{version}
%description SQLite
%{summary}.
%endif
%endif

%package designer
Summary: Interface designer (IDE) for the Qt toolkit
Group: Development/Tools
Requires: %{name}-devel = %{epoch}:%{version}-%{release} 
%description designer
%{summary}.


%prep
#setup -q -n qt-copy
%setup -q -n qt-x11-free-%{version} -a 1

%if "%{?qtcopy:1}" == "1"

# Is this really needed anymore?  -- Rex
%patch1000 -p1 -b .head

# drop 0036-qprogressbar-optimization.patch, it's binary-incompatible with stock qt -- Rex
echo "0036" >> patches/DISABLED
# use fedora's buildkey patch instead -- Rex
echo "0064" >> patches/DISABLED
%if "%{version}" > "3.3.6"
echo "0072" >> patches/DISABLED
%endif

[ -x apply_patches ] && ./apply_patches

[ -f Makefile.cvs ] && make -f Makefile.cvs

%endif

%patch1 -p1 -b .cjk
%patch2 -p1 -b .ndebug
%patch3 -p1 -b .makefile
%patch5 -p1
%patch7 -p1 -b .quiet
%patch8 -p1 -b .qembed
%patch12 -p1 -b .nostdlib
%patch13 -p1 -b .fonts
%patch14 -p1 -b .gl
%patch19 -p1 -b .gtk
%patch20 -p1 -b .gcc4-buildkey

%if "%{?enable_hidden_visibility}" == "1"
%patch23 -p1 -b .hidden_visibility
%endif

%patch24 -p1 -b .uic
%patch25 -p1 -b .uic-multilib

%if "%{?immodule:1}" == "1"
%patch50 -p1 -b .pre
%patch51 -p1
%patch52 -p1 -b .post
%patch53 -p1 -b .quiet
%patch54 -p1 -b .fix-key-release-event-with-imm
%patch55 -p1 -b .resetinputcontext
%endif

%if "%{?qtcopy:1}" != "1"
%patch100 -p0 -b .0038-dragobject-dont-prefer-unknown
%patch101 -p0 -b .0047-fix-kmenu-width
%patch102 -p0 -b .0048-qclipboard_hack_80072
%patch103 -p0 -b .0056-khotkeys_input_84434
%patch104 -p0 -b .0069-fix-minsize
%patch105 -p0 -b .0070-fix-broken-fonts
%endif

%patch200 -p1 -b .fullscreen

## kde-redhat patches
#patch1001 -p1 -b .PSfontname
%if "%{version}" < "3.3.7"
%patch1003 -p0 -b .CVE-2006-4811
%endif

# clean up source tree
find . -type d -name CVS | xargs rm -rf
find . -type d -name .svn | xargs rm -rf

# convert to UTF-8
iconv -f iso-8859-1 -t utf-8 < doc/man/man3/qdial.3qt > doc/man/man3/qdial.3qt_
mv doc/man/man3/qdial.3qt_ doc/man/man3/qdial.3qt


%build
export QTDIR=$(pwd)
export QTLIB=${QTDIR}/lib QTINC=${QTDIR}/include
export LD_LIBRARY_PATH="$QTDIR/lib:$LD_LIBRARY_PATH"
export PATH="$QTDIR/bin:$PATH"
export QTDEST=%{qtdir}

%{?immodule:sh ./make-symlinks.sh}

%if "%{?x_modular:1}" == "1"
# set correct X11 prefix
sed -i -e "s,QMAKE_LIBDIR_X11.*,QMAKE_LIBDIR_X11\t=," mkspecs/*/qmake.conf
sed -i -e "s,QMAKE_INCDIR_X11.*,QMAKE_INCDIR_X11\t=," mkspecs/*/qmake.conf
sed -i -e "s,QMAKE_INCDIR_OPENGL.*,QMAKE_INCDIR_OPENGL\t=," mkspecs/*/qmake.conf
sed -i -e "s,QMAKE_LIBDIR_OPENGL.*,QMAKE_LIBDIR_OPENGL\t=," mkspecs/*/qmake.conf
%endif

# don't use rpath.  NO, PyQt needs this, really. -- Rex
# sed -i -e "s|-Wl,-rpath,| |" mkspecs/*/qmake.conf

# use $RPM_OPT_FLAGS for our platform
%if "%{_lib}" == "lib64"
%define platform linux-g++-64
%else
%define platform linux-g++
%endif
sed -i -e "s|-O2|$RPM_OPT_FLAGS|g" mkspecs/%{platform}/qmake.conf

# set correct lib path
if [ "%{_lib}" != "lib" ] ; then
  sed -i -e "s,/lib /usr/lib,/%{_lib} /usr/%{_lib},g" config.tests/unix/checkavail
  sed -i -e "s,/usr/lib /lib,/usr/%{_lib} /%{_lib},g" config.tests/{unix,x11}/*.test
  sed -i -e "s,/lib /usr/lib,/%{_lib} /usr/%{_lib},g" config.tests/{unix,x11}/*.test
fi

# build default (shared, threaded) libraries
echo yes | ./configure -v \
  -prefix $QTDEST \
  -docdir %{qt_docdir} \
  -libdir %{qt_libdir} \
  -platform %{platform} \
  -release \
  -shared \
  -dlopen-opengl \
  -largefile \
  -qt-gif \
  -system-zlib \
  -system-libpng \
  -system-libmng \
  -system-libjpeg \
  -no-g++-exceptions \
  -enable-tools \
  -enable-kernel \
  -enable-widgets \
  -enable-dialogs \
  -enable-iconview \
  -enable-workspace \
  -enable-network \
  -enable-canvas \
  -enable-table \
  -enable-xml \
  -qt-imgfmt-png -qt-imgfmt-jpeg -qt-imgfmt-mng \
  %{?plugins_sql} \
  %{?nas} %{!?nas:-no-nas-sound} \
  %{plugins_style} \
  -stl \
  -thread \
  -cups \
  -sm \
  -xkb \
  -ipv6 \
  -xinerama \
  -xrender %{?xft} %{?xrandr} 

%if "%{?buildSQL}" == "1"
# build psql plugin
# FIXME/TODO: pg_config -- Rex
pushd plugins/src/sqldrivers/psql
qmake -o Makefile "INCLUDEPATH+=/usr/include/pgsql /usr/include/pgsql/server /usr/include/pgsql/internal" "LIBS+=-lpq" psql.pro
popd

# build mysql plugin 
# FIXME/TODO: mysql_config -- Rex
%define mysql_include_dir %{_includedir}/mysql
%define mysql_lib_dir %{_libdir}/mysql
pushd plugins/src/sqldrivers/mysql
qmake -o Makefile "INCLUDEPATH+=%{mysql_include_dir}" "LIBS+=-L%{mysql_lib_dir} -lmysqlclient" mysql.pro
popd

# build odbc plugin
pushd plugins/src/sqldrivers/odbc
qmake -o Makefile "LIBS+=-lodbc" odbc.pro
popd

# build sqlite(2) plugin
%if "%{?buildsqlite}" == "1"
pushd plugins/src/sqldrivers/sqlite
qmake -o Makefile "LIBS+=-lsqlite" sqlite.pro
popd
%endif
%endif

make %{?_smp_mflags} 


%install
rm -rf %{buildroot}
export QTDIR=$(pwd)
export QTINC=${QTDIR}/include
export QTLIB=${QTDIR}/lib
export PATH=$QTDIR/bin:$PATH
export MANPATH=$QTDIR/doc/man:$MANPATH
export LD_LIBRARY_PATH=$QTDIR/lib:$LD_LIBRARY_PATH
export QTDEST=%{qtdir}

mkdir -p %{buildroot}{%{_docdir}/qt{,-devel}-%{version},%{_mandir}/{man1,man3}}
mkdir -p %{buildroot}%{qtdir}/{bin,include}
mkdir -p %{buildroot}%{qt_libdir}

make install INSTALL_ROOT=%{buildroot}/

# create/fix symlinks
/sbin/ldconfig -n %{buildroot}%{qt_libdir}
for link in qt.so qt.so.3 ; do
  ln -sf libqt-mt.so.%{version} %{buildroot}%{qt_libdir}/lib${link}
done

# lib64 fixes
pushd mkspecs
rm -rf default
if [ "%{_lib}" == "lib64" ]; then
   ln -sf linux-g++-64 default
else
   ln -sf linux-g++ default
fi
popd
cp -aR mkspecs %{buildroot}%{qtdir}

# strip extraneous dirs/libraries -- Rex
# safe ones
for dep in -laudio -lmng -ljpeg -lpng -lz -lfreetype -lm -L%{_libdir}/mysql ; do
  sed -i -e "s| $dep||" %{buildroot}%{qt_libdir}/lib*.la ||:
  sed -i -e "s| $dep||" %{buildroot}%{qt_libdir}/pkgconfig/*.pc
  sed -i -e "s| $dep||" %{buildroot}%{qt_libdir}/*.prl
done
# not-so-safe, but we can try -- Rex
for dep in -L/usr/X11R6/%{_lib} -lXrender -lXrandr -lXt -lXcursor -lXinerama -lXft -lfontconfig -lXext -lX11 -lSM -lICE -ldl -lpthread ; do
  sed -i -e "s| $dep||" %{buildroot}%{qt_libdir}/lib*.la ||:
  sed -i -e "s| $dep||" %{buildroot}%{qt_libdir}/pkgconfig/*.pc
  sed -i -e "s| $dep||" %{buildroot}%{qt_libdir}/*.prl
done
sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" %{buildroot}%{qt_libdir}/*.prl

# pkg-config
mkdir -p %{buildroot}%{_libdir}/pkgconfig/
mv %{buildroot}%{qt_libdir}/pkgconfig/*.pc %{buildroot}%{_libdir}/pkgconfig/

# install man pages
mkdir -p %{buildroot}%{_mandir}
cp -a doc/man/* %{buildroot}%{_mandir}/

## docs
# make symbolic link to qt docdir
rm -rf %{buildroot}%{qtdir}/doc
ln -s  ../../share/doc/%{name}-devel-%{version} %{buildroot}%{qtdir}/doc

## Fixup examples/tutorials
# Make sure the examples can be built outside the source tree.
# Our binaries fulfill all requirements, so...
sed -i -e "s,^DEPENDPATH.*,,g;s,^REQUIRES.*,,g" `find examples -name "*.pro"`

for a in */*/Makefile ; do
  sed 's|^SYSCONF_MOC.*|SYSCONF_MOC		= %{qtdir}/bin/moc|' < $a > ${a}.2
  mv -v ${a}.2 $a
done

# don't include Makefiles of qt examples/tutorials
make -C examples clean
make -C tutorial clean
find examples -name "Makefile" | xargs rm -f
find examples -name "*.obj" | xargs rm -rf
find examples -name "*.moc" | xargs rm -rf
find tutorial -name "Makefile" | xargs rm -f

## qt.sh, qt.csh
mkdir -p %{buildroot}/etc/profile.d
install -p -m755 -D %{SOURCE10} %{buildroot}/etc/profile.d/qt.sh
install -p -m755 -D %{SOURCE11}	%{buildroot}/etc/profile.d/qt.csh
sed -i -e "s|@@QTDIR@@|%{qtdir}|" %{buildroot}/etc/profile.d/qt.*

for i in findtr qt20fix qtrename140 lupdate lrelease; do
  if [ ! -f %{buildroot}%{qtdir}/bin/$i ]; then
  install -p -m755 bin/$i %{buildroot}%{qtdir}/bin/
  else
  echo "$i already installed in %{qtdir}/bin/ ... skipped."
  fi
done

# Add desktop file(s)
desktop-file-install \
  --dir %{buildroot}%{_datadir}/applications \
  --vendor="%{name}" \
  --remove-key=MapNotify \
  %{SOURCE20} %{SOURCE21} %{SOURCE22} %{SOURCE23}

%if "%{?redhat_artwork:1}" != "1"
# Sane default settings
install -p -m644 -D %{SOURCE2} %{buildroot}%{qtdir}/etc/settings/qtrc
%endif

# prepare to own possibly-generated config(s)
mkdir -p %{buildroot}%{qtdir}/etc/settings
touch %{buildroot}%{qtdir}/etc/settings/qt_plugins_3.3rc

# remove broken links
rm -f %{buildroot}%{qtdir}/mkspecs/default/linux-g++*
# .la files, die die die
rm -f %{buildroot}%{qt_libdir}/lib*.la

# for newer ld.so's
%if "%{?ld_so_conf_d}" == "1"
mkdir -p %{buildroot}/etc/ld.so.conf.d
echo "%{qt_libdir}" > %{buildroot}/etc/ld.so.conf.d/qt-%{_arch}.conf
%endif


%clean
rm -rf %{buildroot}


%pre devel-docs
# This *should* be a symlink
test -d "%{qtdir}/doc" -a ! -L "%{qtdir}/doc"  && /bin/rm -rf "%{qtdir}/doc" ||:
exit 0

%post
%if "%{?ld_so_conf_d}" != "1" 
grep "^%{qt_libdir}" ||  echo "%{qt_libdir}" >> /etc/ld.so.conf ||:
%endif
/sbin/ldconfig ||:

%postun
%if "%{?ld_so_conf_d}" != "1"
if [ $1 -eq 0 ]; then
  grep -v "^%{qt_libdir}" /etc/ld.so.conf > /etc/ld.so.conf.new 2>/dev/null ||:
  mv -f /etc/ld.so.conf.new /etc/ld.so.conf ||:
fi
%endif
/sbin/ldconfig ||:


%files
%defattr(-,root,root,-)
%doc FAQ LICENSE.QPL README* changes*
%if "%{?ld_so_conf_d}" == "1"
/etc/ld.so.conf.d/*
%endif
%dir %{qtdir}
%dir %{qtdir}/bin
%dir %{qt_libdir}
%{qt_libdir}/lib*.so.*
%{qtdir}/phrasebooks
%dir %{qtdir}/etc
%dir %{qtdir}/etc/settings
%{!?redhat_artwork:%config(noreplace) %{qtdir}/etc/settings/qtrc}
%ghost %verify(not md5 size mtime) %{qtdir}/etc/settings/qt_plugins_3.3rc
%dir %{qtdir}/plugins
%{?immodule:%{qtdir}/plugins/inputmethods}

%files config
%defattr(-,root,root,-)
%{qtdir}/bin/qtconfig
%{_datadir}/applications/*qtconfig.desktop

%files devel
%defattr(-,root,root,-)
%attr(0755,root,root) %config /etc/profile.d/*
%{qtdir}/bin/moc
%{qtdir}/bin/uic
%{qtdir}/bin/findtr
%{qtdir}/bin/qt20fix
%{qtdir}/bin/qtrename140
%{qtdir}/bin/assistant
%{qtdir}/bin/qm2ts
%{qtdir}/bin/qmake
%{qtdir}/bin/qembed
%{qtdir}/bin/linguist
%{qtdir}/bin/lupdate
%{qtdir}/bin/lrelease
%{qtdir}/include/
%{qtdir}/mkspecs/
%{qt_libdir}/lib*.so
%{qt_libdir}/lib*.a
%{_libdir}/pkgconfig/*.pc
%{qt_libdir}/*.prl
%{qtdir}/templates/
%{qtdir}/translations/
%{_mandir}/*/*
%{_datadir}/applications/*linguist.desktop

%files devel-docs
%defattr(-,root,root,-)
%{qtdir}/bin/assistant
%{_datadir}/applications/*assistant.desktop
%dir %{qt_docdir}
%{qtdir}/doc
%{qt_docdir}/html
%doc examples
%doc tutorial

%if "%{?styleplugins}" == "1"
%files styles
%defattr(-,root,root,-)
%dir %{qtdir}/plugins/styles
%{qtdir}/plugins/styles/*
%endif

%if "%{?buildSQL}" == "1"
%files ODBC
%defattr(-,root,root,-)
%{qtdir}/plugins/sqldrivers/libqsqlodbc*

%files PostgreSQL
%defattr(-,root,root,-)
%{qtdir}/plugins/sqldrivers/libqsqlpsql*

%files MySQL
%defattr(-,root,root,-)
%{qtdir}/plugins/sqldrivers/libqsqlmysql*

%if "%{?buildsqlite}" == "1"
%files SQLite
%defattr(-,root,root,-)
%{qtdir}/plugins/sqldrivers/libqsqlite*
%endif
%endif

%files designer
%defattr(-,root,root,-)
#{_bindir}/designer*
%dir %{qtdir}/plugins/designer
%{qtdir}/plugins/designer/*
%{qtdir}/bin/designer
%{_datadir}/applications/*designer.desktop


%changelog
* Fri Nov 03 2006 Rex Dieter 3.3.7-0.2
- since qt-copy hasn't been updated to 3.3.7 yet, use upstream (trolltech)
  qt-3.3.7, and apply qt-copy patches
- drop legacy (ie, XFree86) bits
- drop static build bits (can't remember *ever* using that)

* Mon Oct 23 2006 Rex Dieter 3.3.6-13.4 
- fix pre-modular-X libGL/libGLU deps (#211898)

* Mon Oct 23 2006 Rex Dieter 3.3.6-13.3
- -devel-docs: own %%qtdir/doc symlink
- -devel-docs: Requires: qt (instead of qt-devel)
- -devel-docs: Provides: %%name-doc

* Wed Oct 18 2006 Rex Dieter 3.3.6-13.2
- CVE-2006-4811 qt integer overflow (bug 210742)

* Wed Sep 27 2006 Rex Dieter 3.3.6-13.1
- -devel-docs: own %%qt_docdir

* Wed Sep 27 2006 Rex Dieter 3.3.6-13.0
- strip -lXt from .pc/.la/.prl files too
- -system-nas-sound (fc5+, el4+)
- use %%qt_libdir
- qt.(sh|csh): to add $QTDIR/bin to $PATH, drop %%_bindir symlinks
- qt-copy-3.3-svn20060609

* Thu Aug 31 2006 Than Ngo <than@redhat.com> 1:3.3.6-13
- add missing desktop files

* Mon Jul 17 2006 Than Ngo <than@redhat.com> 1:3.3.6-12
- rebuild

* Mon Jul 10 2006 Than Ngo <than@redhat.com> 1:3.3.6-11
- apply upstream patches, fix arabic fonts issue, and
  problems with missing minimum size when richtext
  labels are used

* Thu Jun 29 2006 Than Ngo <than@redhat.com> 1:3.3.6-10
- apply patch from Lars, fixes Qt 3.3.6 for Arabic fonts

* Wed Jun 28 2006 Than Ngo <than@redhat.com> 1:3.3.6-9
- fix #183302, IM preedit issue in kbabel

* Mon Jun 26 2006 Than Ngo <than@redhat.com> 1:3.3.6-8
- rebuilt

* Thu Jun 08 2006 Than Ngo <than@redhat.com> 1:3.3.6-7
- fix utf8 issue in changelog
- fix #195410, don't strip binaries/libraries
- fix #156572, keyReleaseEvent issue

* Mon Jun 05 2006 Than Ngo <than@redhat.com> 1:3.3.6-6
- qt-devel requires on mesa-libGLU-devel mesa-libGU-devel

* Tue May 16 2006 Than Ngo <than@redhat.com> 1:3.3.6-5
- fix #191895, BR libXmu-devel

* Mon May 15 2006 Than Ngo <than@redhat.com> 1:3.3.6-4
- fix multilib issue

* Tue May 09 2006 Than Ngo <than@redhat.com> 1:3.3.6-3
- add subpackage qt-devel-docs #191099

* Thu Apr 13 2006 Than Ngo <than@redhat.com> 1:3.3.6-2
- fix xorg prefix #188510

* Sun Apr 09 2006 Rex Dieter 1:3.3.6-1.0
- qt-copy-3.3-svn527993

* Mon Mar 31 2006 Than Ngo <than@redhat.com> 1:3.3.6-1
- update to 3.3.6
- adapt qt-x11-immodule-unified-qt3.3.5-20060318 to qt-3.3.6
- remove set of fixes for the immodule patch, included in qt-x11-immodule-unified-qt3.3.5-20060318
- remove 0051-qtoolbar_77047.patch, qt-x11-free-3.3.4-assistant_de.patch,
  qt-x11-free-3.3.5-warning.patch, included in new upstream

* Fri Mar 31 2006 Rex Dieter 1:3.3.5-13.2
- BR: libGL-devel libGLU-devel 

* Mon Mar 27 2006 Rex Dieter 1:3.3.5-13.1
- respin to get qtdir right.

* Fri Mar 24 2006 Rex Dieter 1:3.3.5-13.0
- include some qt-immodule patches from kde-packagers

* Fri Feb 17 2006 Rex Dieter 1:3.3.5-11.4
- use Requires(hint) for optional bits (redhat-artwork)

* Tue Feb 07 2006 Rex Dieter 1:3.3.5-11.3.kde
- qt.(sh|csh): *really* set/use QTLIB/QTINC

* Tue Jan 10 2006 Rex Dieter 1:3.3.5-11.1.kde
- -devel: Req: libpng-devel, libjpeg-devel  
  (not *really* required, but makes life simpler, and matches rawhide)

* Wed Dec 21 2005 Rex Dieter 1:3.3.5-11.0.kde
- strip extrenous libraries from pkgconfig/qt-mt.pc
- option to build sqlite(2) plugin
- qt-copy-20051215, disable experimental fontconfig patches:
  0066-fcsort2fcmatch.patch, 0067-nofclist.patch  

* Wed Dec 21 2005 Than Ngo <than@redhat.com> 1:3.3.5-11 
- BuildRequires on libXt-devel/xorg-x11-proto-devel

* Sun Nov 13 2005 Than Ngo <than@redhat.com> 1:3.3.5-10
- workaround for keyboard input action in KHotKeys

* Tue Nov 08 2005 Than Ngo <than@redhat.com> 1:3.3.5-9
- fix for modular X

* Tue Nov 08 2005 Than Ngo <than@redhat.com> 1:3.3.5-8
- get rid of xorg-x11-devel, fix for modular X

* Tue Oct 25 2005 Than Ngo <than@redhat.com> 1:3.3.5-7
- update qt-x11-immodule-unified-qt3.3.5-20051012-quiet.patch

* Mon Oct 24 2005 Than Ngo <than@redhat.com> 1:3.3.5-6
- update qt-x11-immodule-unified-qt3.3.5-20051018.diff
- remove unneeded qt-x11-immodule-unified-qt3.3.5-20051012-build.patch

* Thu Oct 13 2005 Than Ngo <than@redhat.com> 1:3.3.5-5
- update qt-x11-immodule-unified-qt3.3.5-20051012
- disable some debug messages
- apply patch to fix build problem with the new immodule patch

* Wed Aug 24 2005 Rex Dieter 1:3.3.4-17.3.kde
- fc4/gcc4: use fedora's value of "4.*" instead of qt-copy's
  "4.0*" to generate qt's BUILD_KEY

* Tue Aug 23 2005 Rex Dieter 1:3.3.4-17.2.kde
- qt-copy-20050823

* Mon Aug 08 2005 Rex Dieter 1:3.3.4-17.1.kde
- visibility patch (kde bug #109386)

* Wed Jul 27 2005 Rex Dieter 1:3.3.4-17.0.kde
- qt-copy-20050126
- immodule=1 (disabled still on rh73/gcc296)
- relax plugin Req's: %%name = %%{version}
- PSfontname patch
- unconditionally use desktop_file, pkgconfig, cups
- buildable all the way back to rh73.
- don't drop usage of -rpath (PyQt needs it)
- -devel: drop bogus Requires: libpng-devel, libjpeg-devel, libmng-devel
- %%ghost %%{qtdir}/etc/settings/qt_plugins_3.3rc
- sql macro: mysql4 -> mysql3: use mysql_v4 by default, if available, unless
  mysql3 is defined.

* Wed Jul 20 2005 Than Ngo <than@redhat.com> 1:3.3.4-17
- fix German translation of the Qt Assistent #161558

* Mon Jun 27 2005 Than Ngo <than@redhat.com> 1:3.3.4-16
- apply patch to fix Rendering for Punjabii, thanks to Trolltech #156504

* Tue May 24 2005 Than Ngo <than@redhat.com> 1:3.3.4-15
- add better fix for #156977, thanks to trolltech
- apply patch to fix keyReleaseEvent problem #156572

* Wed May 18 2005 Than Ngo <than@redhat.com> 1:3.3.4-14
- apply patch to use ecvt, fcvt (thanks to Jakub)
- fix a bug in printing of postscript #156977

* Wed May 18 2005 Than Ngo <than@redhat.com> 1:3.3.4-13
- rebuild

* Thu Apr 14 2005 Than Ngo <than@redhat.com> 1:3.3.4-12
- fix bad symlink #154086

* Wed Apr 13 2005 Than Ngo <than@redhat.com> 1:3.3.4-11
- remove bad symlink #154086
- built with PostgresSQL 8.0.2

* Wed Mar 23 2005 Than Ngo <than@redhat.com> 1:3.3.4-10
- add GtkStyle patch from Peter Backlund #141125

* Fri Mar 04 2005 Than Ngo <than@redhat.com> 1:3.3.4-9
- fix buildkey issue with gcc-4

* Fri Mar 04 2005 Than Ngo <than@redhat.com> 1:3.3.4-8
- rebuilt against gcc-4.0.0-0.31

* Tue Mar 01 2005 Than Ngo <than@redhat.com> 1:3.3.4-7
- fix build problem with gcc4

* Mon Feb 28 2005 Than Ngo <than@redhat.com> 1:3.3.4-6
- rebuilt against gcc-4

* Tue Feb 22 2005 Than Ngo <than@redhat.com> 1:3.3.4-5
- fix application crash when input methode not available (bug #140658)
- remove .moc/.obj
- add qt-copy patch to fix KDE #80072

* Fri Feb 11 2005 Than Ngo <than@redhat.com> 1:3.3.4-4
- update qt-x11-immodule-unified patch

* Thu Feb 10 2005 Than Ngo <than@redhat.com> 1:3.3.4-3
- fix rpm file conflict

* Wed Feb 02 2005 Than Ngo <than@redhat.com> 1:3.3.4-2
- remove useless doc files #143949
- fix build problem if installman is disable #146311
- add missing html/examples/tutorial symlinks

* Fri Jan 28 2005 Than Ngo <than@redhat.com> 1:3.3.4-1
- update to 3.3.4
- adapt many patches to qt-3.3.4
- drop qt-x11-free-3.3.0-freetype, qt-x11-free-3.3.3-qmake, qt-x11-free-3.3.1-lib64
  qt-x11-free-3.3.3-qimage, which are included in new upstream

* Tue Nov 30 2004 Than Ngo <than@redhat.com> 1:3.3.3-16
- add sql macro

* Mon Nov 29 2004 Than Ngo <than@redhat.com> 1:3.3.3-15
- convert qdial.3qt to UTF-8 bug #140946

* Tue Nov 23 2004 Than Ngo <than@redhat.com> 1:3.3.3-14
- add missing lupdate and lrelease #140230

* Fri Nov 19 2004 Than Ngo <than@redhat.com> 1:3.3.3-13
- apply patch to fix qinputcontext

* Thu Nov 11 2004 Than Ngo <than@redhat.com> 1:3.3.3-12
- link against MySQL 3
- fix rpm conflict

* Wed Nov 10 2004 Than Ngo <than@redhat.com> 1:3.3.3-11
- apply patch to fix fullscreen problem
- remove html documents duplicate #135696

* Tue Nov 02 2004 Than Ngo <than@redhat.com> 1:3.3.3-10
- rebuilt

* Tue Nov 02 2004 Than Ngo <than@redhat.com> 1:3.3.3-9
- remove unused patch
- set XIMInputStyle=On The Spot
- require xorg-x11-devel instead XFree86-devel

* Thu Oct 14 2004 Than Ngo <than@redhat.com> 1:3.3.3-8
- don't compress examples/tutorial

* Thu Oct 07 2004 Than Ngo <than@redhat.com> 1:3.3.3-7
- fix build problem without qt immodule #134918

* Tue Sep 28 2004 Than Ngo <than@redhat.com> 1:3.3.3-6
- fix font problem, bz #133578

* Tue Sep 14 2004 Than Ngo <than@redhat.com> 1:3.3.3-4
- update new immodule patch
- fix multilib problem #132516

* Tue Sep 14 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.3-3.3
- -devel: remove Requires: libjpeg-devel, libmng-devel, libpng-devel

* Mon Sep 13 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.3-3.2
- try immodule patch from kde-packagers (redhat bug #132304)

* Fri Sep 10 2004 Rex Dieter <rexdieter at sf.net. 1:3.3.3-3.1
- qt-copy-20040910
- NOTE: immodule enable pending fix for redhat bug #132304

* Mon Aug 23 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.3-3.0
- sync to rawhide's 3.3.3-3

* Fri Aug 13 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.3-2.0
- sync to rawhide 3.3.3-2
- qt-copy-20040813

* Tue Jul 20 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.2-10.2
- fix %%post for non ld.so.conf.d case(s)

* Mon Jul 06 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.2-10.1
- qt-copy-20040706
- disable immodule (for now, redhat bug #127058)

* Mon Jul 06 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.2-10.0
- rawhide sync
- qt-copy-20040530

* Thu Jul 01 2004 Than Ngo <than@redhat.com> 1:3.3.2-10
- add immodule for Qt

* Tue Jun 29 2004 Than Ngo <than@redhat.com> 1:3.3.2-9
- add sub package config, allow multi lib installation (#126643)

* Thu Jun 24 2004 Than Ngo <than@redhat.com> 1:3.3.2-8
- add fontconfig fix for qfontdatabase, #123868
- fix some buildrequires problem, #125289
- fix dangling symlink, #125351
- get rid of backup files

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com> 1:3.3.2-7
- rebuilt

* Tue May 25 2004 Than Ngo <than@redhat.com> 1:3.3.2-5
- add missing qembed tool #124052, #124052
- get rid of unused trigger
- add qt.conf in ld.so.conf.d -> don't change ld.so.conf #124080

* Tue May 18 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.2-2.0
- FC2
- qt-copy-20040513

* Thu May 06 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.2-1.0
- qt-copy-20040506, rawhide's qt-3.3.2-1

* Mon May 03 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.1-1.0
- sync to rawhide's 3.3.1-1.0

* Fri Apr 23 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.1-0.fdr.9
- qt-copy-20040423 (another shot kde bug #77545)

* Thu Apr 22 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.1-0.fdr.8
- qt-copy-20040422 (kde bugs #71529,#77545)

* Mon Apr 12 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.1-0.fdr.7
- qt-copy-20040412

* Wed Apr 07 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.1-0.fdr.6
- sync with rawhide's 3.3.1-0.8

* Mon Apr 05 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.1-0.fdr.5
- qt-copy-20040405

* Sun Apr 04 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.1-0.fdr.4
- make themer more robust

* Mon Mar 29 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.1-0.fdr.3
- PSfontname patch
- qt-copy-20040329

* Wed Mar 10 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.1-0.fdr.2
- sync with rh's qt-3.3.1-0.5

* Tue Mar 09 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.1-0.fdr.1
- 3.3.1

* Tue Mar 02 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.0-0.fdr.2
- disable -dlopen-opengl (for now, too buggy)

* Mon Mar 01 2004 Rex Dieter <rexdieter at sf.net> 1:3.3.0-0.fdr.1
- 3.3.0
- try -dlopen-opengl, nope too buggy.
- nuke -styles subpkg (it was more trouble than it's worth)

* Thu Feb 12 2004 Rex Dieter <rexdieter at sf.net> 1:3.2.3-0.fdr.9
- desktop_file=1 unconditionally
- Requires(post,preun): themer -> Prereq: themer
- create libqt.so.3 symlink

* Tue Jan 13 2004 Rex Dieter <rexdieter at sf.net> 1:3.2.3-0.fdr.8
- qt-theme returns!

* Sun Jan 11 2004 Rex Dieter <rexdieter at sf.net> 1:3.2.3-0.fdr.7
- allow -rpath's in mkspecs, breaks PyQt when missing:
  http://mats.imk.fraunhofer.de/pipermail/pykde/2003-December/006674.html

* Fri Dec 19 2003 Rex Dieter <rexdieter at sf.net> 1:3.2.3-0.fdr.6
- don't use themer/alternatives for qt anymore (it *should* be
  inheriting from kde).

* Wed Dec 03 2003 Rex Dieter <rexdieter at sf.net> 1:3.2.3-0.fdr.5
- don't disable -Wall anymore, it ended up disabling it for all
  qt-based projects (using qmake).

* Mon Dec 01 2003 Rex Dieter <rexdieter at sf.net> 1:3.2.3-0.fdr.4
- use qt-copy, and use its not-yet-accepted-by-tt patches
- (rh73/gcc296) fix uic issue(s): use -fuse-cxa-atexit

* Tue Nov 25 2003 Rex Dieter <rexdieter at sf.net> 1:3.2.3-0.fdr.3
- respin

* Thu Nov 20 2003 Rex Dieter <rexdieter at sf.net> 1:3.2.3-0.fdr.2
- rh73: rebuild against fontconfig'd version of XFree86-4.2.1

* Mon Nov 17 2003 Rex Dieter <rexdieter at sf.net> 1:3.2.3-0.fdr.1
- add/use qfontdatabase patch on rh73 too
- sync w/rawhide's 3.2.2-0.4
- styleplugins subpkg.
- update macros for Fedora Core.
- handle pkgconfig file

* Wed Nov 12 2003 Rex Dieter <rexdieter at sf.net> 1:3.2.3-0.fdr.0
- first shot at 3.2
- use qt-copy (3.2.3)

* Tue Oct 21 2003 Rex Dieter <rexdieter at sf.net> 1:3.1.2-7.fdr.3
- qt-3.1.3-qpsprinter-fix-ttf-font.patch

* Sat Aug 23 2003 Rex Dieter <rexdieter at sf.net> 1:3.1.2-7.fdr.2
- sync to rawhide's 3.1.2-14
- move /etc/profile.d/* from -devel to main pkg.
- own alternatives
- use themer tool.

* Thu Jul 31 2003 Rex Dieter <rexdieter at sf.net> 1:3.1.2-7.fdr.1 
- (default) theme handling: simplify, handle upgrades better.

* Fri May 23 2003 Rex Dieter <rexdieter at sf.net> 1:3.1.2-7.fdr.0
- fixup Conflicts for fedora'ized packages.

* Mon May 19 2003 Than Ngo <than@redhat.com> 3.1.2-7
- add some patches from KDE CVS qt-copy, thanks to Alexei Podtelezhnikov

* Fri May 09 2003 Rex Dieter <rexdieter at users.sf.net> 1:3.1.2-5.1.fdr.1
- cleanup %%files list to remove duplicates.

* Thu May 08 2003 Rex Dieter <rexdieter at users.sf.net> 1:3.1.2-5.1.fdr.0
- add cvs tags.
- use fedora naming scheme.
- sync to 3.1.2-5.1.

* Mon May  5 2003 Than Ngo <than@redhat.com> 3.1.2-5.1
- set correct permission config scripts

* Tue Apr 29 2003 Than Ngo <than@redhat.com> 3.1.2-4
- fix typo bug in font loader

* Wed Jan 29 2003 Than Ngo <than@redhat.com> 3.1.1-6
- add missing Categories section in qt designer #82920

* Mon Dec 30 2002 Florian La Roche <Florian.LaRoche@redhat.de> 3.1.1-4
- Change qmlined.h to not include an attic header that is also not shipped
  with Red Hat Linux. This also fixes building unixODBC, that includes this
  header (apparently also without needing it).

* Thu Dec 19 2002 Than Ngo <than@redhat.com> 3.1.1-3
- add monospace patch file from Leon Ho (bug #79949)
- add small patch file from Sysoltsev Slawa (bug #79731)

* Tue Dec 17 2002 Than Ngo <than@redhat.com> 3.1.1-2
- don't require XFree86, it's not needed

* Tue Dec 17 2002 Than Ngo <than@redhat.com> 3.1.1-1
- update to 3.1.1

* Thu Nov 28 2002 Than Ngo <than@redhat.com> 3.1.0-1.3
- don't write Date into created moc files

* Mon Nov 18 2002 Than Ngo <than@redhat.com> 3.1.0-1.2
- add missing libs
- remove workaround for ppc

* Sun Nov 17 2002 Than Ngo <than@redhat.com> 3.1.0-1.1
- adjust qfontdatabase_x11 for 3.1.0
- fix lib64 issue
- add workaround to build on ppc

* Wed Nov 13 2002 Than Ngo <than@redhat.com> 3.1.0-1
- update to 3.1.0
- adjust some patch files for 3.1.0
- clean up specfile
- remove some Xft2 patch files, which are now in 3.1.0
- add qwidget_x11.cpp.diff from Trolltech
- install qt in %%{_libdir}/qt-3.1 (bug #77706)
- don't use rpath
- enable large file support
- use system Xinerama
- remove unneeded cups patch file
- fix to build against new XFree86
